/*
	ExternalInterface test code for GNU Flash Player
	Written (2016) by Nutchanon Wetchasit <Nutchanon.Wetchasit@gmail.com>
	
	Released to public domain under Creative Commons Zero 1.0
	(https://creativecommons.org/publicdomain/zero/1.0/)
*/
import flash.external.*;

class JS2FlashReturnTypes {
	private static function string_call() {
		trace("callee: string_call callback invoked");
		return "Hello!";
	}
	
	private static function error_call() {
		trace("callee: error_call callback invoked");
		return "Error";
	}
	
	private static function securityerror_call() {
		trace("callee: securityerror_call callback invoked");
		return "SecurityError";
	}
	
	private static function integer_call() {
		trace("callee: integer_call callback invoked");
		return 1234;
	}
	
	private static function float_call() {
		trace("callee: float_call callback invoked");
		return 1234.5678;
	}
	
	private static function infinite_call() {
		trace("callee: infinite_call callback invoked");
		return Infinity;
	}
	
	private static function neginfinite_call() {
		trace("callee: neginfinite_call callback invoked");
		return -Infinity;
	}
	
	private static function nan_call() {
		trace("callee: nan_call callback invoked");
		return NaN;
	}
	
	private static function boolean_call() {
		trace("callee: boolean_call callback invoked");
		return true;
	}
	
	private static function null_call() {
		trace("callee: null_call callback invoked");
		return null;
	}
	
	private static function noret_call() {
		trace("callee: noret_call callback invoked");
	}
	
	private static function undefined_call() {
		trace("callee: undefined_call callback invoked");
		return undefined;
	}
	
	private static function exception_call() {
		trace("callee: exception_call callback invoked");
		throw new Error("This is a test ActionScript Error");
	}
	
	private static function array_call() {
		trace("callee: array_call callback invoked");
		return new Array("The","quick","brown","fox","jumps","over","the","lazy","dog");
	}
	
	private static function object_call() {
		var object;
		
		trace("callee: object_call callback invoked");
		object=new Object();
		object.a="Hello";
		object.b="World";
		return object;
	}
	
	private static function object_customstring_call() {
		var object_customstring;
		
		trace("callee: object_customstring_call callback invoked");
		object_customstring=new Object();
		object_customstring.toString=function() {
			return "This is object_customstring.toString()";
		};
		return object_customstring;
	}
	
	private static function object_customvalue_call() {
		var object_customvalue;
		
		trace("callee: object_customvalue_call callback invoked");
		object_customvalue=new Object();
		object_customvalue.valueOf=function() {
			return 5;
		};
		return object_customvalue;
	}
	
	private static function function_call() {
		trace("callee: function_call callback invoked");
		return function() {
			trace("Hiya?");
		};
	}
	
	public static function main(mc:MovieClip):Void {
		var retval;
		
		if(!ExternalInterface.available) {
			trace("callee: ExternalInterface is unavailable, aborting");
			return;
		}
		if(!ExternalInterface.addCallback("string_call",mc,string_call)) {
			trace("callee: failed registering string_call callback");
		}
		if(!ExternalInterface.addCallback("error_call",mc,error_call)) {
			trace("callee: failed registering error_call callback");
		}
		if(!ExternalInterface.addCallback("securityerror_call",mc,securityerror_call)) {
			trace("callee: failed registering securityerror_call callback");
		}
		if(!ExternalInterface.addCallback("integer_call",mc,integer_call)) {
			trace("callee: failed registering integer_call callback");
		}
		if(!ExternalInterface.addCallback("float_call",mc,float_call)) {
			trace("callee: failed registering float_call callback");
		}
		if(!ExternalInterface.addCallback("infinite_call",mc,infinite_call)) {
			trace("callee: failed registering infinite_call callback");
		}
		if(!ExternalInterface.addCallback("neginfinite_call",mc,neginfinite_call)) {
			trace("callee: failed registering neginfinite_call callback");
		}
		if(!ExternalInterface.addCallback("nan_call",mc,nan_call)) {
			trace("callee: failed registering nan_call callback");
		}
		if(!ExternalInterface.addCallback("boolean_call",mc,boolean_call)) {
			trace("callee: failed registering boolean_call callback");
		}
		if(!ExternalInterface.addCallback("null_call",mc,null_call)) {
			trace("callee: failed registering null_call callback");
		}
		if(!ExternalInterface.addCallback("noret_call",mc,noret_call)) {
			trace("callee: failed registering noret_call callback");
		}
		if(!ExternalInterface.addCallback("undefined_call",mc,undefined_call)) {
			trace("callee: failed registering undefined_call callback");
		}
		if(!ExternalInterface.addCallback("exception_call",mc,exception_call)) {
			trace("callee: failed registering exception_call callback");
		}
		if(!ExternalInterface.addCallback("array_call",mc,array_call)) {
			trace("callee: failed registering array_call callback");
		}
		if(!ExternalInterface.addCallback("object_call",mc,object_call)) {
			trace("callee: failed registering object_call callback");
		}
		if(!ExternalInterface.addCallback("object_customstring_call",mc,object_customstring_call)) {
			trace("callee: failed registering object_customstring_call callback");
		}
		if(!ExternalInterface.addCallback("object_customvalue_call",mc,object_customvalue_call)) {
			trace("callee: failed registering object_customvalue_call callback");
		}
		if(!ExternalInterface.addCallback("function_call",mc,function_call)) {
			trace("callee: failed registering function_call callback");
		}
		trace("callee: finished initializing");
	}
}
